rem echo on

rem run one test, check errors and verify assembly
rem
rem %1        = fast, full or test name
rem %2        = test name
rem %3        = noopt or opt or -386
rem %4        = -ox or -oX
rem %5        = target
rem %6 .. %9  = other jal command line arguments
rem 

if not %1 == fast echo    %3 %4

:compile
if exist %2.asm del %2.asm
if exist %2.hex del %2.hex
if exist %2.dif del %2.dif
jal -rc -slib -stest -sdoc -vZ %4 %5 %6 %7 %8 %9 > %2.out
if not errorlevel 2 goto asm
echo JAL ERROR in %2 %3 %5
echo     JAL ERROR in %2 %3 %5 >>errors.out
echo >stop.flg
goto done

:asm
if %1 == fast goto done
if not exist %2.asm goto done
if exist %2.jh del %2.jh
if exist %2.mh del %2.mh
if exist %2.txt del %2.txt
rename %2.hex %2.jh
mpasm /q %2.asm
if not errorlevel 1 goto compare
echo MPASM ERROR in %2 %3 %5
echo     MPASM ERROR in %2 %3 %5 >>errors.out
echo >stop.flg
goto done

:compare
if exist %2.mh del %2.mh
rename %2.hex %2.mh
diff %2.jh %2.mh >%2.dif
if not errorlevel 1 goto ok
echo HEX ERROR in %2 %3 %5
echo     HEX ERROR in %2 %3 %5 >>errors.out
echo >stop.flg
goto done

:ok
if exist error.flg del error.flg

:done
if exist %2.cod del %2.cod
